/*
  Written in March 2002 by Vaclav Cermak
*/

/*
  Edge class
*/

#ifndef _FE_EDGE_H
#define _FE_EDGE_H

#include <vector>
#include <list>

#include "basic.h"

class FeVertex;
class FeWing;

class FeEdge: public FeBasic {
 private:
  FeVertex *mvpVertices[2];   // Endpoints of edge
  vector<FeWing *> mvpWings;    // List of all faces using this edge

 public:
  FeEdge(FeVertex *a, FeVertex *b);
  virtual ~FeEdge();

  FeVertex & operator [] (int a);
  
  FeVertex &v0();
  FeVertex &v1();

  void addWing(FeWing *pw);

  FeWing *createWing(const FeVertex *v0, const FeVertex *v1);

  void invalidatePrecomputedValues();

  virtual void checkTopology();
};

#endif
