
#ifndef _FE_EQUATIONS_H
#define _FE_EQUATIONS_H

#include <map>
#include <vector>
#include <string>

using namespace std;

class FeSetOfLinearEquations {
 protected:
  map<string, vector<double> * > mvColumns;
  vector<double> mvEqualsTo;
  map<string, double> mvResults;
  size_t mvNOfEquations;
  bool mvSolved;

 public:
  FeSetOfLinearEquations();
  ~FeSetOfLinearEquations();

  unsigned int newEquations(size_t num); // Reserves space for num equations
  
  double& operator () (size_t row); // Sets equal-to value at row
  double& operator () (string col, size_t row); // Set value at specified col and row

  void solve();

  double operator[] (string name); // Returns result for value specified in column 'name'

  friend ostream & operator << (ostream &os, FeSetOfLinearEquations &eq);
};

#endif
