
#ifndef _EXCEPTION_H
#define _EXCEPTION_H

#include <exception>
#include <string>

using namespace std;

class FeException: public std::exception {
 protected:
  string mvText;
 public:
  FeException(string txt);
  ~FeException() throw() {};

  friend ostream& operator << (ostream &os, const FeException &exc);
};

class FeListEnd: public FeException {
 public:
  FeListEnd(string txt): FeException("FeListEnd (" + txt + ")") {};
};

class FeError: public FeException {
 public:
  FeError(string txt): FeException(txt) {};
};

class FeSolveFailedException: public FeError {
 public:
  FeSolveFailedException(): FeError("FeSolveFailedException") {};
};

#endif
