
#ifndef _PARSER_H
#define _PARSER_H

#define MAX_LINE_LEN 2048
#define MAX_LIST_LEN 64

#include <stdio.h>

#include <vector>

#include "body.h"
#include "model.h"

class FeParser {
 private:
  FILE *mvInputFile;

  FeModel *mvpActModel;
  FeBody *mvpActBody;
  int mvNumOfBodies;

  char mvActLine[MAX_LINE_LEN];
  const char *mvpActChar;
  
  char mvBuffer[MAX_LINE_LEN];

  int mvNumberOfIntegersInList;
  int mvListOfIntegers[MAX_LIST_LEN];

 public:

  FeParser(FeModel *model, FILE *inputFile=stdin);

  bool readLine(int mode=0);
  
  int getInteger();
  double getFloat();
  bool getBoolean();
  const char *getIdentifier();

  FeVector getVector();
  int getListOfIntegers(); // Return number of integers in list
  int *copyListOfIntegers();

  void getFacesDetails(int num, FeFace **faces);
  void getBodyDetails(FeBody *);
  void getInterfaceProperties();

  void startBody();
  void endBody(int numOfFaces, FeFace **);

  FeBody *getTetrahedron();
  FeBody *getPyramid();
  FeBody *getPrism();
  FeBody *getWedge();
  
  void getVertices();

  FeBody *getBody();

  FeModel *getModel();
};

#endif

