
/*
  Written in March 2002 by Vaclav Cermak
*/

/*
  Vertex class
*/

#ifndef _FE_VERTEX_H
#define _FE_VERTEX_H

#include <list>

#include "vector.h"

class FeEdge;
class FeModel;
class FeWing;

// Vertex class definition
class FeVertex: public FeVector {
  friend class FeModel;
 protected:
  list<FeEdge *> mvpEdges;   // List of all edges using this vertex
  FeModel *mvpModel;

 public:
  FeVertex();
  FeVertex(double x, double y, double z);
  FeVertex(const FeVector &v);
  virtual ~FeVertex();

  void addEdge(FeEdge *pe);
  void removeEdge(FeEdge *pe);

  void invalidatePrecomputedValues();

  FeWing *getWingTo(FeVertex *pv);
};


#endif

