/*
  Oook geometry library

  Written in 1998 by Vaclav Cermak (disnel@linux.itam.cas.cz)
  */

#ifndef _OGL_BASIC_H
#define _OGL_BASIC_H

#include <math.h>
#include <iostream>

using namespace std;

//#define _WORK_WITH_MESH_LIBRARY_

#ifdef _USE_GL_
#include <GL/gl.h>
#endif

#include "OGLTypes.h"

#ifdef _WORK_WITH_MESH_LIBRARY_
#include "../mesh/basic.h"
#endif

#ifndef FloatPrec
#define FloatPrec 1e-7
#endif

#ifndef MinFloat
#define MinFloat MINDOUBLE;
#endif

#ifndef MaxFloat
#define MaxFloat MAXDOUBLE;
#endif


#ifndef PI
#define PI 3.14159265358979323846
#endif

#ifndef Sqr
#define Sqr(x) ((x)*(x))
#endif

#ifndef Det2
#define Det2(a, b, c, d) ((a)*(d) - (b)*(c))
#endif

#ifndef Det3
#define Det3(a,b,c, d,e,f, g,h,i) ((a)*(e)*(i) + (d)*(h)*(c) + (g)*(b)*(f) - (g)*(e)*(c) - (d)*(b)*(i) - (a)*(h)*(f))
#endif

#ifndef toRad
#define toRad(x) (PI*x/180.0)
#endif

#endif
