/*
  Oook geometry library

  Written in 1998 by Vaclav Cermak (disnel@linux.itam.cas.cz)

  Two dimensional vector
*/

#ifndef _OGL_VECTOR_2_H
#define _OGL_VECTOR_2_H

#include "OGLBasic.h"

struct OGLVector2 {
  OGLFloat a[2];

  OGLVector2(const OGLFloat x=0.0, const OGLFloat y=0.0);
  OGLVector2(const OGLVector2 &);

  OGLVector2 &operator = (const OGLVector2 &);
  OGLVector2 &operator += (const OGLVector2 &);
  OGLVector2 &operator -= (const OGLVector2 &);

  OGLVector2 operator + (const OGLVector2 &) const;
  OGLVector2 operator - (const OGLVector2 &) const;
  OGLVector2 operator * (const OGLFloat) const;
  OGLVector2 operator / (const OGLFloat) const;

  OGLFloat &operator[] (int);
  OGLFloat operator[] (int) const;

  void selfNormalize();
  OGLVector2 normalize() const;
  OGLFloat sqrLen() const;
  OGLFloat len() const;

  OGLFloat operator ^ (const OGLVector2 &) const;

  friend ostream& operator << (ostream &, const OGLVector2 &);

#ifdef _USE_GL_
  void glVertex();
#endif
};

extern OGLVector2 OGLv2O;
extern OGLVector2 OGLv2X, OGLv2Y;

#endif
