/*
  Oook geometry library

  Written in 1998 by Vaclav Cermak (disnel@linux.itam.cas.cz)

  Three dimensional vector
*/

#ifndef _OGL_VECTOR_3_H
#define _OGL_VECTOR_3_H

#include "OGLBasic.h"
#include "OGLVector2.h"

struct OGLVector3 {
  OGLFloat a[3];

  OGLVector3(const OGLFloat x=0.0, const OGLFloat y=0.0, const OGLFloat z=0.0);
  OGLVector3(const OGLVector2 &);
  OGLVector3(const OGLVector3 &);

  OGLVector3 &operator = (const OGLVector3 &);
  OGLVector3 &operator += (const OGLVector3 &);
  OGLVector3 &operator -= (const OGLVector3 &);

  OGLVector3 operator + (const OGLVector3 &) const;
  OGLVector3 operator - (const OGLVector3 &) const;
  OGLVector3 operator * (const OGLFloat) const;
  OGLVector3 operator / (const OGLFloat) const;

  OGLFloat &operator[] (int);
  OGLFloat operator[] (int) const;

  void selfNormalize();
  void setLen(OGLFloat);
  OGLVector3 normalize() const;
  OGLFloat sqrLen() const;
  OGLFloat len() const;

  OGLFloat operator ^ (const OGLVector3 &) const;
  OGLVector3 operator * (const OGLVector3 &) const;

  friend ostream& operator << (ostream &, const OGLVector3 &);
  friend ostream& operator << (ostream &, const OGLVector3 *);

#ifdef _USE_GL_
  void glVertex();
  void glNormal();
#endif
};

extern OGLVector3 OGLv3O;
extern OGLVector3 OGLv3X, OGLv3Y, OGLv3Z;

#endif
