/*
  Oook geometry library

  Written in 1998 by Vaclav Cermak (disnel@linux.itam.cas.cz)

  Four dimensional vector
*/

#ifndef _OGL_VECTOR_4_H
#define _OGL_VECTOR_4_H

#include "OGLBasic.h"
#include "OGLVector2.h"
#include "OGLVector3.h"

struct OGLVector4 {
  OGLFloat a[4];

  OGLVector4(const OGLFloat x=0.0, const OGLFloat y=0.0, const OGLFloat z=0.0, const OGLFloat d=0.0);
  OGLVector4(const OGLVector2 &);
  OGLVector4(const OGLVector3 &);
  OGLVector4(const OGLVector4 &);

  OGLVector4 &operator = (const OGLVector4 &);
  OGLVector4 &operator += (const OGLVector4 &);
  OGLVector4 &operator -= (const OGLVector4 &);

  OGLVector4 operator + (const OGLVector4 &) const;
  OGLVector4 operator - (const OGLVector4 &) const;
  OGLVector4 operator * (const OGLFloat) const;
  OGLVector4 operator / (const OGLFloat) const;

  OGLFloat &operator[] (int);
  OGLFloat operator[] (int) const;

  void selfNormalize();
  OGLVector4 normalize() const;
  OGLFloat sqrLen() const;
  OGLFloat len() const;

  OGLFloat operator ^ (const OGLVector4 &) const;
  OGLVector4 operator * (const OGLVector4 &) const;

  OGLVector3 createVertex();

  friend ostream& operator << (ostream &, const OGLVector4 &);

#ifdef _USE_GL_
  void glVertex();
#endif
};

#endif
