
#include <ctype.h>

#include "libFailure/libFailure.h"

#include "share.h"

int maxIterations=0;

void printInfo() {
  cout << "|--------------------------------------------------|" << endl;
  cout << "| FAME programs version 1.0.1                      |" << endl;
  cout << "| FAME is released under GNU license (see COPYING) |" << endl;
  cout << "|--------------------------------------------------|" << endl;
  cout << endl;
}

void processParams(int argc, char *argv[]) {
  for (int i=1; i < argc; i++) {
    if (argv[i][0] != '-') throw FeError("Params should start with '-' character");
    switch (argv[i][1]) {
      case 'v':
	if (argc >= i) feDebugLevel=atoi(argv[(i++) + 1]);
	break;
	//      case 'i':
	//	if (argc >= i) maxIterations=atoi(argv[(i++) + 1]);
	//	if (maxIterations > 0) feDebugLevel=0.5;
	//	break;
      default:
	throw FeError("Unknown argument");
    }
  }
}

void doCalculations(FeModel &model) {  
  if (maxIterations) {
    model.findMinimalEqulibriumForce(maxIterations);
  } else {
    try {
      model.findEquilibrium();
    }
    catch (FeException exc) { cout << "Solve failed " << exc << endl; }
  }
}

/*--- End of file ---*/
